import vot
from SPLT_class import MobileTracker
import sys
import cv2
import os

use_vot = True
visual = False
"""VOT """
handle = vot.VOT("rectangle")
selection = handle.region()
imagefile = handle.frame()
if not imagefile:
    sys.exit(0)
if visual:
    save_root = '/media/masterbin-iiau/WIN_SSD/vot20_debug/SPLT'
    seq_name = imagefile.split('/')[-3]
    save_v_dir = os.path.join(save_root,seq_name)
    if not os.path.exists(save_v_dir):
        os.mkdir(save_v_dir)

image = cv2.imread(imagefile)
# print image.shape
tracker = MobileTracker(vot=use_vot, dis=False)
tracker.init_first(image, selection)

while True:
    imagefile = handle.frame()
    if not imagefile:
        break

    image = cv2.imread(imagefile)
    region, confidence = tracker.track(image)
    handle.report(vot.Rectangle(region[0],region[1],region[2],region[3]),confidence)
    # handle.report(region, confidence)
    if visual:
        x1, y1, w, h = region
        cv2.rectangle(image,(int(x1),int(y1)),(int(x1+w),int(y1+h)),(0,0,255),2)
        save_path = os.path.join(save_v_dir,imagefile.split('/')[-1])
        cv2.imwrite(save_path,image)